package cn.superdesk.uniorder.dao.entity.unified.settlement;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class UnifiedSettlementProgrammeExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public UnifiedSettlementProgrammeExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andCustomerIdIsNull() {
            addCriterion("customer_id is null");
            return (Criteria) this;
        }

        public Criteria andCustomerIdIsNotNull() {
            addCriterion("customer_id is not null");
            return (Criteria) this;
        }

        public Criteria andCustomerIdEqualTo(Long value) {
            addCriterion("customer_id =", value, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdNotEqualTo(Long value) {
            addCriterion("customer_id <>", value, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdGreaterThan(Long value) {
            addCriterion("customer_id >", value, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdGreaterThanOrEqualTo(Long value) {
            addCriterion("customer_id >=", value, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdLessThan(Long value) {
            addCriterion("customer_id <", value, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdLessThanOrEqualTo(Long value) {
            addCriterion("customer_id <=", value, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdIn(List<Long> values) {
            addCriterion("customer_id in", values, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdNotIn(List<Long> values) {
            addCriterion("customer_id not in", values, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdBetween(Long value1, Long value2) {
            addCriterion("customer_id between", value1, value2, "customerId");
            return (Criteria) this;
        }

        public Criteria andCustomerIdNotBetween(Long value1, Long value2) {
            addCriterion("customer_id not between", value1, value2, "customerId");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("type is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("type is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(Byte value) {
            addCriterion("type =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(Byte value) {
            addCriterion("type <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(Byte value) {
            addCriterion("type >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(Byte value) {
            addCriterion("type >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(Byte value) {
            addCriterion("type <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(Byte value) {
            addCriterion("type <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<Byte> values) {
            addCriterion("type in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<Byte> values) {
            addCriterion("type not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(Byte value1, Byte value2) {
            addCriterion("type between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(Byte value1, Byte value2) {
            addCriterion("type not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameIsNull() {
            addCriterion("programme_name is null");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameIsNotNull() {
            addCriterion("programme_name is not null");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameEqualTo(String value) {
            addCriterion("programme_name =", value, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameNotEqualTo(String value) {
            addCriterion("programme_name <>", value, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameGreaterThan(String value) {
            addCriterion("programme_name >", value, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameGreaterThanOrEqualTo(String value) {
            addCriterion("programme_name >=", value, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameLessThan(String value) {
            addCriterion("programme_name <", value, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameLessThanOrEqualTo(String value) {
            addCriterion("programme_name <=", value, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameLike(String value) {
            addCriterion("programme_name like", value, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameNotLike(String value) {
            addCriterion("programme_name not like", value, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameIn(List<String> values) {
            addCriterion("programme_name in", values, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameNotIn(List<String> values) {
            addCriterion("programme_name not in", values, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameBetween(String value1, String value2) {
            addCriterion("programme_name between", value1, value2, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNameNotBetween(String value1, String value2) {
            addCriterion("programme_name not between", value1, value2, "programmeName");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoIsNull() {
            addCriterion("programme_no is null");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoIsNotNull() {
            addCriterion("programme_no is not null");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoEqualTo(String value) {
            addCriterion("programme_no =", value, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoNotEqualTo(String value) {
            addCriterion("programme_no <>", value, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoGreaterThan(String value) {
            addCriterion("programme_no >", value, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoGreaterThanOrEqualTo(String value) {
            addCriterion("programme_no >=", value, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoLessThan(String value) {
            addCriterion("programme_no <", value, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoLessThanOrEqualTo(String value) {
            addCriterion("programme_no <=", value, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoLike(String value) {
            addCriterion("programme_no like", value, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoNotLike(String value) {
            addCriterion("programme_no not like", value, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoIn(List<String> values) {
            addCriterion("programme_no in", values, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoNotIn(List<String> values) {
            addCriterion("programme_no not in", values, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoBetween(String value1, String value2) {
            addCriterion("programme_no between", value1, value2, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andProgrammeNoNotBetween(String value1, String value2) {
            addCriterion("programme_no not between", value1, value2, "programmeNo");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeIsNull() {
            addCriterion("settlement_scope is null");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeIsNotNull() {
            addCriterion("settlement_scope is not null");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeEqualTo(Byte value) {
            addCriterion("settlement_scope =", value, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeNotEqualTo(Byte value) {
            addCriterion("settlement_scope <>", value, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeGreaterThan(Byte value) {
            addCriterion("settlement_scope >", value, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeGreaterThanOrEqualTo(Byte value) {
            addCriterion("settlement_scope >=", value, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeLessThan(Byte value) {
            addCriterion("settlement_scope <", value, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeLessThanOrEqualTo(Byte value) {
            addCriterion("settlement_scope <=", value, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeIn(List<Byte> values) {
            addCriterion("settlement_scope in", values, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeNotIn(List<Byte> values) {
            addCriterion("settlement_scope not in", values, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeBetween(Byte value1, Byte value2) {
            addCriterion("settlement_scope between", value1, value2, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementScopeNotBetween(Byte value1, Byte value2) {
            addCriterion("settlement_scope not between", value1, value2, "settlementScope");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleIsNull() {
            addCriterion("settlement_rule is null");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleIsNotNull() {
            addCriterion("settlement_rule is not null");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleEqualTo(Byte value) {
            addCriterion("settlement_rule =", value, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleNotEqualTo(Byte value) {
            addCriterion("settlement_rule <>", value, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleGreaterThan(Byte value) {
            addCriterion("settlement_rule >", value, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleGreaterThanOrEqualTo(Byte value) {
            addCriterion("settlement_rule >=", value, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleLessThan(Byte value) {
            addCriterion("settlement_rule <", value, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleLessThanOrEqualTo(Byte value) {
            addCriterion("settlement_rule <=", value, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleIn(List<Byte> values) {
            addCriterion("settlement_rule in", values, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleNotIn(List<Byte> values) {
            addCriterion("settlement_rule not in", values, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleBetween(Byte value1, Byte value2) {
            addCriterion("settlement_rule between", value1, value2, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andSettlementRuleNotBetween(Byte value1, Byte value2) {
            addCriterion("settlement_rule not between", value1, value2, "settlementRule");
            return (Criteria) this;
        }

        public Criteria andBillNameIsNull() {
            addCriterion("bill_name is null");
            return (Criteria) this;
        }

        public Criteria andBillNameIsNotNull() {
            addCriterion("bill_name is not null");
            return (Criteria) this;
        }

        public Criteria andBillNameEqualTo(String value) {
            addCriterion("bill_name =", value, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameNotEqualTo(String value) {
            addCriterion("bill_name <>", value, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameGreaterThan(String value) {
            addCriterion("bill_name >", value, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameGreaterThanOrEqualTo(String value) {
            addCriterion("bill_name >=", value, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameLessThan(String value) {
            addCriterion("bill_name <", value, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameLessThanOrEqualTo(String value) {
            addCriterion("bill_name <=", value, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameLike(String value) {
            addCriterion("bill_name like", value, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameNotLike(String value) {
            addCriterion("bill_name not like", value, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameIn(List<String> values) {
            addCriterion("bill_name in", values, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameNotIn(List<String> values) {
            addCriterion("bill_name not in", values, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameBetween(String value1, String value2) {
            addCriterion("bill_name between", value1, value2, "billName");
            return (Criteria) this;
        }

        public Criteria andBillNameNotBetween(String value1, String value2) {
            addCriterion("bill_name not between", value1, value2, "billName");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleIsNull() {
            addCriterion("supname_display_rule is null");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleIsNotNull() {
            addCriterion("supname_display_rule is not null");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleEqualTo(Byte value) {
            addCriterion("supname_display_rule =", value, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleNotEqualTo(Byte value) {
            addCriterion("supname_display_rule <>", value, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleGreaterThan(Byte value) {
            addCriterion("supname_display_rule >", value, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleGreaterThanOrEqualTo(Byte value) {
            addCriterion("supname_display_rule >=", value, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleLessThan(Byte value) {
            addCriterion("supname_display_rule <", value, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleLessThanOrEqualTo(Byte value) {
            addCriterion("supname_display_rule <=", value, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleIn(List<Byte> values) {
            addCriterion("supname_display_rule in", values, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleNotIn(List<Byte> values) {
            addCriterion("supname_display_rule not in", values, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleBetween(Byte value1, Byte value2) {
            addCriterion("supname_display_rule between", value1, value2, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andSupnameDisplayRuleNotBetween(Byte value1, Byte value2) {
            addCriterion("supname_display_rule not between", value1, value2, "supnameDisplayRule");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameIsNull() {
            addCriterion("custom_supplier_name is null");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameIsNotNull() {
            addCriterion("custom_supplier_name is not null");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameEqualTo(String value) {
            addCriterion("custom_supplier_name =", value, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameNotEqualTo(String value) {
            addCriterion("custom_supplier_name <>", value, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameGreaterThan(String value) {
            addCriterion("custom_supplier_name >", value, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameGreaterThanOrEqualTo(String value) {
            addCriterion("custom_supplier_name >=", value, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameLessThan(String value) {
            addCriterion("custom_supplier_name <", value, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameLessThanOrEqualTo(String value) {
            addCriterion("custom_supplier_name <=", value, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameLike(String value) {
            addCriterion("custom_supplier_name like", value, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameNotLike(String value) {
            addCriterion("custom_supplier_name not like", value, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameIn(List<String> values) {
            addCriterion("custom_supplier_name in", values, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameNotIn(List<String> values) {
            addCriterion("custom_supplier_name not in", values, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameBetween(String value1, String value2) {
            addCriterion("custom_supplier_name between", value1, value2, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andCustomSupplierNameNotBetween(String value1, String value2) {
            addCriterion("custom_supplier_name not between", value1, value2, "customSupplierName");
            return (Criteria) this;
        }

        public Criteria andIsDefaultIsNull() {
            addCriterion("is_default is null");
            return (Criteria) this;
        }

        public Criteria andIsDefaultIsNotNull() {
            addCriterion("is_default is not null");
            return (Criteria) this;
        }

        public Criteria andIsDefaultEqualTo(Byte value) {
            addCriterion("is_default =", value, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultNotEqualTo(Byte value) {
            addCriterion("is_default <>", value, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultGreaterThan(Byte value) {
            addCriterion("is_default >", value, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultGreaterThanOrEqualTo(Byte value) {
            addCriterion("is_default >=", value, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultLessThan(Byte value) {
            addCriterion("is_default <", value, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultLessThanOrEqualTo(Byte value) {
            addCriterion("is_default <=", value, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultIn(List<Byte> values) {
            addCriterion("is_default in", values, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultNotIn(List<Byte> values) {
            addCriterion("is_default not in", values, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultBetween(Byte value1, Byte value2) {
            addCriterion("is_default between", value1, value2, "isDefault");
            return (Criteria) this;
        }

        public Criteria andIsDefaultNotBetween(Byte value1, Byte value2) {
            addCriterion("is_default not between", value1, value2, "isDefault");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNull() {
            addCriterion("create_user_id is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIsNotNull() {
            addCriterion("create_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdEqualTo(Long value) {
            addCriterion("create_user_id =", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotEqualTo(Long value) {
            addCriterion("create_user_id <>", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThan(Long value) {
            addCriterion("create_user_id >", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("create_user_id >=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThan(Long value) {
            addCriterion("create_user_id <", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("create_user_id <=", value, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdIn(List<Long> values) {
            addCriterion("create_user_id in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotIn(List<Long> values) {
            addCriterion("create_user_id not in", values, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdBetween(Long value1, Long value2) {
            addCriterion("create_user_id between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andCreateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("create_user_id not between", value1, value2, "createUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNull() {
            addCriterion("update_user_id is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIsNotNull() {
            addCriterion("update_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdEqualTo(Long value) {
            addCriterion("update_user_id =", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotEqualTo(Long value) {
            addCriterion("update_user_id <>", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThan(Long value) {
            addCriterion("update_user_id >", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("update_user_id >=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThan(Long value) {
            addCriterion("update_user_id <", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdLessThanOrEqualTo(Long value) {
            addCriterion("update_user_id <=", value, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdIn(List<Long> values) {
            addCriterion("update_user_id in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotIn(List<Long> values) {
            addCriterion("update_user_id not in", values, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdBetween(Long value1, Long value2) {
            addCriterion("update_user_id between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIdNotBetween(Long value1, Long value2) {
            addCriterion("update_user_id not between", value1, value2, "updateUserId");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNull() {
            addCriterion("deleted is null");
            return (Criteria) this;
        }

        public Criteria andDeletedIsNotNull() {
            addCriterion("deleted is not null");
            return (Criteria) this;
        }

        public Criteria andDeletedEqualTo(Byte value) {
            addCriterion("deleted =", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotEqualTo(Byte value) {
            addCriterion("deleted <>", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThan(Byte value) {
            addCriterion("deleted >", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedGreaterThanOrEqualTo(Byte value) {
            addCriterion("deleted >=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThan(Byte value) {
            addCriterion("deleted <", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedLessThanOrEqualTo(Byte value) {
            addCriterion("deleted <=", value, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedIn(List<Byte> values) {
            addCriterion("deleted in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotIn(List<Byte> values) {
            addCriterion("deleted not in", values, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedBetween(Byte value1, Byte value2) {
            addCriterion("deleted between", value1, value2, "deleted");
            return (Criteria) this;
        }

        public Criteria andDeletedNotBetween(Byte value1, Byte value2) {
            addCriterion("deleted not between", value1, value2, "deleted");
            return (Criteria) this;
        }

        public Criteria andEnabledIsNull() {
            addCriterion("enabled is null");
            return (Criteria) this;
        }

        public Criteria andEnabledIsNotNull() {
            addCriterion("enabled is not null");
            return (Criteria) this;
        }

        public Criteria andEnabledEqualTo(Byte value) {
            addCriterion("enabled =", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledNotEqualTo(Byte value) {
            addCriterion("enabled <>", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledGreaterThan(Byte value) {
            addCriterion("enabled >", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledGreaterThanOrEqualTo(Byte value) {
            addCriterion("enabled >=", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledLessThan(Byte value) {
            addCriterion("enabled <", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledLessThanOrEqualTo(Byte value) {
            addCriterion("enabled <=", value, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledIn(List<Byte> values) {
            addCriterion("enabled in", values, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledNotIn(List<Byte> values) {
            addCriterion("enabled not in", values, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledBetween(Byte value1, Byte value2) {
            addCriterion("enabled between", value1, value2, "enabled");
            return (Criteria) this;
        }

        public Criteria andEnabledNotBetween(Byte value1, Byte value2) {
            addCriterion("enabled not between", value1, value2, "enabled");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}